program formatos
!el estandar para FORTRAN tiene reservados dos valores para espeificar I/O al usuario. 
!valor = 5  para ingreso/INPUT desde teclado/keyboard usando comando READ
!valor = 6  para salida/OUTPUT para pantalla suando comando WRITE
!La mayoria de las versiones de FORTRAN usan el asterisco (*) para I/O en el TERMINAL.
!el asterisco puede ser usado tanto en READ como WRITE,po lo que no es necesario recordar lo del 5 o 6
!por ello se coloca: write(*, algo)
!en cuanto a las salidas con formato
! algo suele ser *: que es salida sin formato definido.
! el siguiente ejemplo explica como usar formatos especficos.
!     Descriptor          Uso                           
!     rIw                 Integer 
!     rFw.d               Real  en notacion decimal
!     rEw.d               Real en notacion cientifica
!     Aw                  Caracter 
!     'x...x'             cadenas de caracteres
!     nX                  espaciado horizontal
!     /                   espaciado vertical 
!     Tc                  Tab
!donde:
!         w  = positive integer specifying FIELD WIDTH
!         r  = positive integer REPEAT COUNT
!         d  = non-negative integer specifying number of digits to display to right of decimal.
!         x  = any character
!         n  = positive integer specifying number of columns
!         c  = positive integer representing column number
                    
implicit none
INTEGER :: x = 3, y = -5, z = 128
REAL :: a = 12.34, b = 0.945, c = 100.0, d=12.68
LOGICAL::Ver= .TRUE., Fal=.FALSE.
CHARACTER(5) :: p = "abcde"
CHARACTER(LEN=2) :: q = "MI"
CHARACTER :: r="*"

! CARACTERES y cadenas de caracteres.
! descriptor: rAw
WRITE(*,*) "ejemplos con cadenas de caracteres"
WRITE(*,'(A6)')  "12345" !deja un espacio antes del 12345, si el formato es menor, lo trunca.
WRITE(*,'(A)')  p
WRITE(*,'(A)')  q
WRITE(*,"(A,A3,A)")  p, q, r

! ENTEROS: descriptor: rIw  ,o bien  rIw.m
WRITE(*,"(/,A)") "ejemplos con ENTEROS"
WRITE(*,"(I4.2)")  x, y, z
WRITE(*,*) "Con espacio entre variables:"
WRITE(*,"(I4.2,A,I4.3,A,I4.4)")  x," ", y," ", z !I4.2: 4 espacios, muestra 2 digitos.
												 !(A)para caracteres: un espacio
                                                 !I4.3: 4 espacios, muestra 3 digitos, rellena con 0
												 !(A)para caracteres: un espacio
                                                 !I4.2: 4 espacios, muestra 4 digitos, rellena con 0
WRITE(*,*) "Con salto de lnea entre primera variable y las otras dos:"
WRITE(*,"(I4.2,/,I4.2,I4.4)")  x, y, z                                                 
! w es el ancho del campo, cantidad de espacios a utilizar para escribir el numero
! m las posiciones de las w posiciones, si el numero tiene menos de m digitos, se rellena con 0s,
! si tiene ms de m digitos, m debiera ser ignorado.
! r es el repetidor.

! LOGICOS: descriptor: rLw
WRITE(*,"(/,A)") "ejemplos con variables LOGICAS:"
write (*,*) Ver,Fal
write (*,'(L1,L2)') Ver,Fal !el primero tiene largo1, el segundo largo2 la F sale en la ultima pos.
write (*,'(L3,L4)') Ver,Fal


! REALES : descriptor: rFw.d
WRITE(*,"(/,A)") "Ejemplos con REALES:"
WRITE(*,*)  a, b, c
WRITE(*,"(F4.1)")  c !no me cabe la cantidad de elementos en el largo total
					  !formato rFw.d: F es float, w cantidad total de digitos (incluidos despues de la coma)
                      !d digitos despues de la coma. como tengo 4 digitos (100) y he dejado uno despus
                      ! de la coma, no me alcanza a mostrar el 100 completo por eso rellena con ***
                      !conclusion: w debe ser mayor o igual a d+2
                      !r: numero de repeticiones del formato.
WRITE (*,*) "de a cuatro"
WRITE(*,"(4F8.1)")   a, b, c, d
WRITE (*,*) "de a tres"
WRITE(*,"(3F8.1)")   a, b, c, d
WRITE (*,*) "de a dos"
WRITE(*,"(2F8.1)")   a, b, c, d
WRITE (*,*) "de a uno"
WRITE(*,"(1F8.1)")   a, b, c, d
WRITE (*,*) "de a uno alternativo"
WRITE(*,"(F8.1)")   a, b, c, d
end program